Bug 1129946

Summary: [RFE][glance]: Metadata Definitions Catalog
Product: Red Hat OpenStack Reporter: RHOS Integration <rhos-integ>
Component: openstack-glanceAssignee: Flavio Percoco <fpercoco>
Status: CLOSED CURRENTRELEASE QA Contact: nlevinki <nlevinki>
Severity: high Docs Contact:
Priority: unspecified    
Version: unspecifiedCC: eglynn, fpercoco, markmc, rhos-flags, scohen, yeylon
Target Milestone: gaKeywords: CodeChange, FutureFeature, ZStream
Target Release: 5.0 (RHEL 7)   
Hardware: Unspecified   
OS: Unspecified   
URL: https://blueprints.launchpad.net/glance/+spec/metadata-schema-catalog
Whiteboard: upstream_milestone_juno-rc1 upstream_definition_approved upstream_status_implemented
Fixed In Version: openstack-glance-2014.2.1-3.el7ost Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-02-09 20:05:05 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description RHOS Integration 2014-08-14 04:05:36 UTC
Cloned from launchpad blueprint https://blueprints.launchpad.net/glance/+spec/metadata-schema-catalog.

Description:

A common API hosted by the Glance service for vendors, admins, services, and users to meaningfully define available key / value pair and tag metadata. The intent is to enable better metadata collaboration across artifacts, services, and projects for OpenStack users.

This is about the definition of the available metadata that can be used on different types of resources (images, artifacts, volumes, flavors, aggregates, etc). A definition includes the properties type, its key, it's description, and it's constraints. This catalog will not store the values for specific instance properties.

For example, a definition of a virtual CPU topology property for number of cores will include the key to use, a description, and value constraints like requiring it to be an integer. So, a user, potentially through Horizon, would be able to search this catalog to list the available properties they can add to a flavor or image. They will see the virtual CPU topology property in the list and know that it must be an integer. In the Horizon example, when the user adds the property, its key and value will be stored in the service that owns that resource (Nova for flavors and in Glance for images).

Diagram: https://wiki.openstack.org/w/images/b/bb/Glance-Metadata-API.png

Specification URL (additional information):

https://github.com/openstack/glance-specs/blob/master/specs/juno/metadata-schema-catalog.rst

Comment 2 nlevinki 2014-11-05 09:31:24 UTC
Hi,
I am trying to write a test plan to cover this feature.
Is this feature support the key/value pairs we have or this is for new key/value.
If it's for new key/value pairs cn you send me the list.
Does this feature mean that we are making the key/value format more standard, (i.e key/value/description) ? 
Last question :-), to check it is it enough to check the keys/values in horizen and the glance.conf  file.

Comment 3 Flavio Percoco 2014-11-10 08:58:07 UTC
This feature supports previous and new key/value pairs. As you mentioned, this will help standardizing the properties we have now. You can find them defined here[0] and the documentation is here[1].

TBH, I'm not 100% sure if there's support for this in Horizon, although I believe there is.

[0] https://git.openstack.org/cgit/openstack/glance/tree/etc/metadefs
[1] http://docs.openstack.org/developer/glance/metadefs-concepts.html

Comment 6 Scott Lewis 2015-02-09 20:05:05 UTC
This bug has been closed as a part of the RHEL-OSP 6 general availability release. For details, see https://rhn.redhat.com/errata/rhel7-rhos-6-errata.html